<script setup lang="ts">
import SdgButton from '../components/SdgButton.vue';
import { useGameStore } from '../stores/gameStore';
import { useRouter } from 'vue-router';
import { computed, ref } from 'vue';
import { useFirebaseStore } from '../stores/firebaseStore';
const router = useRouter();

const gameStore = useGameStore();
const firebaseStore = useFirebaseStore();

const onClick = () => {
  router.push({ name: 'panel' });
};

const pointsAvailable = computed(() => gameStore.cashInPoints);
const sdgBucksAvailable = computed(() => gameStore.sdgBucksAvailable);
const canCashIn = computed(() => pointsAvailable.value > 0 && !cashedIn.value);

const cashedIn = ref(false);

const cashIn = async () => {
  await gameStore.cashIn();
  cashedIn.value = true;
};
</script>

<template>
  <div class="grid p-8 m-8 text-xl place-items-center">
    <div class="mb-10 text-3xl">Cash In!</div>
    <div class="mb-10 text-3xl text-fuchsia-600">Thank you for playing sdgpeople!</div>

    <template v-if="canCashIn">
      <div>Every {{ firebaseStore.config.pointsNeededForOneSdgBuck }} points is worth 1 sdg buck.</div>
      <div class="mt-4 text-2xl">Your score is currently: {{ gameStore.points }}.</div>
      <div class="mt-4 text-xl">You can cash in {{ pointsAvailable }} points and earn {{ sdgBucksAvailable }} sdg bucks!</div>
      <div class="mt-4">
        <SdgButton color="bg-green-500" @onClick="cashIn">Convert {{ pointsAvailable }} points to {{ sdgBucksAvailable }} sdg bucks</SdgButton>
      </div>
    </template>

    <template v-else-if="cashedIn">
      <div>You have successfully cashed in! We have recorded your request. On a periodic basis, we look at the transactions and update the sdg bucks balance. If you want your sdg bucks right away, contact Kyle Bakker. Thanks.</div>
    </template>
    <template v-else>
      <div class="mr-8">Your score is currently: {{ gameStore.points }}.</div>
      <div>You have {{ gameStore.points }} points available. You need at least {{ firebaseStore.config.pointsNeededForOneSdgBuck }} points. Keep playing!.</div>
    </template>

    <div class="mt-4">
      <SdgButton color="bg-sdg-blue" @onClick="onClick">
        <span class="text-black">Back to sdgpeople!</span>
      </SdgButton>
    </div>
  </div>
</template>
